<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 9</a>

    <script>
        //Incompleto
        class Node {
            constructor(data) {
                this.key = data;
                this.left = null;
                this.right = null;
            }
        }

        function secuencias(inicio, final) {
                var list = [];

                if (inicio > final) {
                    list.push(null);
                    return list;
                }
                
                for (var i = inicio; i < final; i++) {
                    var leftArbol = secuencias(inicio, i - 1);
                    var rightArbol = secuencias(i + 1, final);
                    
                    for (var j = 0; j < leftArbol.length; j++) {
                        var left = leftArbol[j];
                        for (var k = 0; k < rightArbol.length; k++) {
                            var right = rightArbol[k];
                            var node = new Node(i)
                            node.left = left;
                            node.left = right;
                            list.push(node);
                        }
                    }
                }
                return list;
            }

        function preorden(root) {
                if (root != null) {
                    document.write(root.key+" ") ;
                    preorden(root.left);
                    preorden(root.right); 
                }
        }

        var totalArboles = secuencias(1,3);

        document.write("Preorder traversals of all" +
                        "constructed BSTs are<br>");
for (var i = 0; i < totalArboles.length; i++)
{
    preorder(totalArboles[i]);
    document.write("<br>");
}
        
 

    </script>
    
</body>
</html>